<%@ WebHandler Language="C#" Class="TinySpell" %>

using System;
using System.Net;
using System.Web;

public class TinySpell : IHttpHandler {
    private const string SpellerUrl = "http://speller.yandex.net/services/tinyspell";

    public void ProcessRequest(HttpContext context) {
        HttpRequest request = context.Request;
        HttpResponse response = context.Response;

        WebRequest webRequest = WebRequest.Create(SpellerUrl);
        webRequest.Method = "POST";
        webRequest.ContentType = request.ContentType;

        int len = 0;
        byte[] buf = new byte[1024];
        while ((len = request.InputStream.Read(buf, 0, buf.Length)) != 0)
            webRequest.GetRequestStream().Write(buf, 0, len);
        webRequest.GetRequestStream().Close();

        WebResponse webResponse = webRequest.GetResponse();
        response.ContentType = webResponse.ContentType;

        while ((len = webResponse.GetResponseStream().Read(buf, 0, buf.Length)) != 0)
            response.OutputStream.Write(buf, 0, len);
    }

    public bool IsReusable {
        get {
            return false;
        }
    }
}
